<!DOCTYPE html>

<html lang="en" data-content_root="../../">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>cnp.app &#8212; numpy 0.0.post1.dev4+gdc3df0d documentation</title>
    <link rel="stylesheet" type="text/css" href="../../_static/pygments.css?v=fa44fd50" />
    <link rel="stylesheet" type="text/css" href="../../_static/alabaster.css?v=233b9934" />
    <script src="../../_static/documentation_options.js?v=a3874995"></script>
    <script src="../../_static/doctools.js?v=888ff710"></script>
    <script src="../../_static/sphinx_highlight.js?v=dc90522c"></script>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
   
  <link rel="stylesheet" href="../../_static/custom.css" type="text/css" />
  
  
  <meta name="viewport" content="width=device-width, initial-scale=0.9, maximum-scale=0.9" />

  </head><body>
  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          

          <div class="body" role="main">
            
  <h1>Source code for cnp.app</h1><div class="highlight"><pre>
<span></span><span class="kn">import</span> <span class="nn">click</span>
<span class="kn">import</span> <span class="nn">numpy</span> <span class="k">as</span> <span class="nn">np</span>
<span class="kn">import</span> <span class="nn">logging</span>


<span class="c1"># logging.getLogger().setLevel(logging.DEBUG)</span>

<div class="viewcode-block" id="Storage">
<a class="viewcode-back" href="../../api/cnp.html#cnp.app.Storage">[docs]</a>
<span class="k">class</span> <span class="nc">Storage</span><span class="p">:</span>
    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">heap</span> <span class="o">=</span> <span class="nb">dict</span><span class="p">()</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">stack</span> <span class="o">=</span> <span class="nb">list</span><span class="p">()</span></div>


<span class="nd">@click</span><span class="o">.</span><span class="n">group</span><span class="p">(</span><span class="n">chain</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
<span class="nd">@click</span><span class="o">.</span><span class="n">pass_context</span>
<span class="k">def</span> <span class="nf">cli</span><span class="p">(</span><span class="n">ctx</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    NumPy Array CLI manipulation</span>

<span class="sd">    This CLI allows users to perform operations on NumPy arrays from the command line.</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">ctx</span><span class="o">.</span><span class="n">obj</span> <span class="o">=</span> <span class="n">Storage</span><span class="p">()</span>


<div class="viewcode-block" id="process_commands">
<a class="viewcode-back" href="../../api/cnp.html#cnp.app.process_commands">[docs]</a>
<span class="nd">@cli</span><span class="o">.</span><span class="n">result_callback</span><span class="p">()</span>
<span class="k">def</span> <span class="nf">process_commands</span><span class="p">(</span><span class="n">processors</span><span class="p">,</span> <span class="o">**</span><span class="n">kwds</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    This result callback is invoked with an iterable of all the chained</span>
<span class="sd">    subcommands.  Each subcommand returns a function that is chained together</span>
<span class="sd">    to feed one into the other, similar to how a pipe on unix works.</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="c1"># Start with an empty iterable.</span>
    <span class="n">stream</span> <span class="o">=</span> <span class="p">()</span>

    <span class="c1"># Pipe it through all stream processors.</span>
    <span class="k">for</span> <span class="n">processor</span> <span class="ow">in</span> <span class="n">processors</span><span class="p">:</span>
        <span class="n">stream</span> <span class="o">=</span> <span class="n">processor</span><span class="p">(</span><span class="n">stream</span><span class="p">)</span>

    <span class="c1"># Evaluate the stream and throw away the items.</span>
    <span class="k">for</span> <span class="n">_</span> <span class="ow">in</span> <span class="n">stream</span><span class="p">:</span>
        <span class="k">pass</span></div>



<span class="c1"># Commands are added in other modules</span>
<span class="kn">from</span> <span class="nn">.inout</span> <span class="kn">import</span> <span class="p">(</span>
    <span class="n">dumps</span><span class="p">,</span> <span class="n">read</span><span class="p">,</span> <span class="n">write</span>
<span class="p">)</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">dumps</span><span class="p">)</span>  <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">read</span><span class="p">)</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">write</span><span class="p">)</span>  <span class="c1"># tested</span>

<span class="kn">from</span> <span class="nn">.nparray</span> <span class="kn">import</span> <span class="p">(</span>
    <span class="n">random</span><span class="p">,</span> <span class="n">elementwise_unary_generator</span><span class="p">,</span> <span class="n">axiswise_unary_generator</span><span class="p">,</span> <span class="n">binary_generator</span><span class="p">,</span> <span class="n">binary_ufunc_generator</span>
<span class="p">)</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">random</span><span class="p">)</span>  <span class="c1"># tested</span>
<span class="c1"># ---- Mathematical Functions (https://numpy.org/doc/stable/reference/routines.math.html) -----</span>
<span class="c1"># Trigonometric functions</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">elementwise_unary_generator</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">sin</span><span class="p">))</span>  <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">elementwise_unary_generator</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">cos</span><span class="p">))</span>  <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">elementwise_unary_generator</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">tan</span><span class="p">))</span>  <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">elementwise_unary_generator</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">arcsin</span><span class="p">))</span>  <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">elementwise_unary_generator</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">arccos</span><span class="p">))</span>  <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">elementwise_unary_generator</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">arctan</span><span class="p">))</span>  <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">binary_ufunc_generator</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">hypot</span><span class="p">))</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">binary_ufunc_generator</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">arctan2</span><span class="p">))</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">elementwise_unary_generator</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">degrees</span><span class="p">))</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">elementwise_unary_generator</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">radians</span><span class="p">))</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">elementwise_unary_generator</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">unwrap</span><span class="p">))</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">elementwise_unary_generator</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">deg2rad</span><span class="p">))</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">elementwise_unary_generator</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">rad2deg</span><span class="p">))</span>

<span class="c1"># Hyperbolic functions </span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">elementwise_unary_generator</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">sinh</span><span class="p">))</span>  <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">elementwise_unary_generator</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">cosh</span><span class="p">))</span>  <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">elementwise_unary_generator</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">tanh</span><span class="p">))</span>  <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">elementwise_unary_generator</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">arcsinh</span><span class="p">))</span>  <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">elementwise_unary_generator</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">arccosh</span><span class="p">))</span>  <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">elementwise_unary_generator</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">arctanh</span><span class="p">))</span>  <span class="c1"># tested</span>

<span class="c1"># Rounding</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">elementwise_unary_generator</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">round</span><span class="p">))</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">elementwise_unary_generator</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">around</span><span class="p">))</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">elementwise_unary_generator</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">rint</span><span class="p">))</span> <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">elementwise_unary_generator</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">fix</span><span class="p">))</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">elementwise_unary_generator</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">floor</span><span class="p">))</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">elementwise_unary_generator</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">ceil</span><span class="p">))</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">elementwise_unary_generator</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">trunc</span><span class="p">))</span>

<span class="c1"># Sums, products, differences </span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">axiswise_unary_generator</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">prod</span><span class="p">))</span> <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">axiswise_unary_generator</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">sum</span><span class="p">))</span> <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">axiswise_unary_generator</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">nanprod</span><span class="p">))</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">axiswise_unary_generator</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">nansum</span><span class="p">))</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">axiswise_unary_generator</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">cumprod</span><span class="p">))</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">axiswise_unary_generator</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">cumsum</span><span class="p">))</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">axiswise_unary_generator</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">nancumprod</span><span class="p">))</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">axiswise_unary_generator</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">nancumsum</span><span class="p">))</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">axiswise_unary_generator</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">diff</span><span class="p">))</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">axiswise_unary_generator</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">ediff1d</span><span class="p">))</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">axiswise_unary_generator</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">gradient</span><span class="p">))</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">axiswise_unary_generator</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">cross</span><span class="p">))</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">axiswise_unary_generator</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">trapz</span><span class="p">))</span>

<span class="c1"># Exponents and logarithms</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">elementwise_unary_generator</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">exp</span><span class="p">))</span>  <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">elementwise_unary_generator</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">expm1</span><span class="p">))</span>  <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">elementwise_unary_generator</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">exp2</span><span class="p">))</span>  <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">elementwise_unary_generator</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">log</span><span class="p">))</span>  <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">elementwise_unary_generator</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">log10</span><span class="p">))</span>  <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">elementwise_unary_generator</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">log2</span><span class="p">))</span>  <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">elementwise_unary_generator</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">log1p</span><span class="p">))</span>  <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">binary_ufunc_generator</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">logaddexp</span><span class="p">))</span>  <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">binary_ufunc_generator</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">logaddexp2</span><span class="p">))</span>  <span class="c1"># tested</span>

<span class="c1"># Arithmetic operations</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">binary_ufunc_generator</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">add</span><span class="p">))</span>  <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">elementwise_unary_generator</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">reciprocal</span><span class="p">))</span>  <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">elementwise_unary_generator</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">negative</span><span class="p">))</span>  <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">elementwise_unary_generator</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">positive</span><span class="p">))</span> <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">binary_ufunc_generator</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">multiply</span><span class="p">))</span>  <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">binary_ufunc_generator</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">divide</span><span class="p">))</span>  <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">binary_ufunc_generator</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">power</span><span class="p">))</span>  <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">binary_ufunc_generator</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">subtract</span><span class="p">))</span>  <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">(</span><span class="s2">&quot;true-divide&quot;</span><span class="p">)(</span><span class="n">binary_ufunc_generator</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">true_divide</span><span class="p">))</span>  <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">(</span><span class="s2">&quot;floor-divide&quot;</span><span class="p">)(</span><span class="n">binary_ufunc_generator</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">floor_divide</span><span class="p">))</span>  <span class="c1"># tested</span>
<span class="c1"># float_power (unnecessary?)</span>
<span class="c1"># fmod</span>
<span class="c1"># mod (unnecessary? == np.remainder)</span>
<span class="c1"># modf</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">binary_ufunc_generator</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">remainder</span><span class="p">))</span>  <span class="c1"># tested</span>

<span class="c1"># Handling complex numbers</span>
<span class="c1"># angle</span>
<span class="c1"># real</span>
<span class="c1"># imag</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">(</span><span class="s2">&quot;conj&quot;</span><span class="p">)(</span><span class="n">elementwise_unary_generator</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">conj</span><span class="p">))</span>  <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">elementwise_unary_generator</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">conjugate</span><span class="p">))</span>  <span class="c1"># tested</span>

<span class="c1"># Extrema Finding</span>
<span class="c1"># maximum</span>
<span class="c1"># max</span>
<span class="c1"># amax</span>
<span class="c1"># fmax</span>
<span class="c1"># nanmax</span>
<span class="c1"># minimum</span>
<span class="c1"># min</span>
<span class="c1"># amin</span>
<span class="c1"># fmin</span>
<span class="c1"># nanmin</span>

<span class="c1"># Miscellaneous</span>
<span class="c1"># convolve</span>
<span class="c1"># clip</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">elementwise_unary_generator</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">sqrt</span><span class="p">))</span>  <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">elementwise_unary_generator</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">cbrt</span><span class="p">))</span>  <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">elementwise_unary_generator</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">square</span><span class="p">))</span>  <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">(</span><span class="s2">&quot;abs&quot;</span><span class="p">)(</span><span class="n">elementwise_unary_generator</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">abs</span><span class="p">))</span>  <span class="c1"># tested</span>
<span class="c1"># fab</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">elementwise_unary_generator</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">sign</span><span class="p">))</span>  <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">binary_ufunc_generator</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">heaviside</span><span class="p">))</span>  <span class="c1"># tested</span>
<span class="c1"># nan_to_num</span>
<span class="c1"># real_if_close</span>
<span class="c1"># interp</span>

<span class="c1"># Rational routines</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">binary_ufunc_generator</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">gcd</span><span class="p">))</span>  <span class="c1"># FAILED: must be ints. Need &quot;astype&quot;</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">binary_ufunc_generator</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">lcm</span><span class="p">))</span>  <span class="c1"># FAILED: must be ints. Need &quot;astype&quot;</span>

<span class="c1"># ----- Linear algebra -----</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">binary_generator</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">matmul</span><span class="p">))</span>  <span class="c1"># tested</span>
</pre></div>

          </div>
          
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<h1 class="logo"><a href="../../index.html">numpy</a></h1>








<h3>Navigation</h3>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../readme.html">Overview</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../cnp.html">Reference</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../contributing.html">Contributions &amp; Help</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../license.html">License</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../authors.html">Authors</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../changelog.html">Changelog</a></li>
</ul>

<div class="relations">
<h3>Related Topics</h3>
<ul>
  <li><a href="../../index.html">Documentation overview</a><ul>
  <li><a href="../index.html">Module code</a><ul>
  </ul></li>
  </ul></li>
</ul>
</div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false"/>
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>document.getElementById('searchbox').style.display = "block"</script>








        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="footer">
      &copy;2023, Contextualize.
      
      |
      Powered by <a href="http://sphinx-doc.org/">Sphinx 7.2.6</a>
      &amp; <a href="https://github.com/bitprophet/alabaster">Alabaster 0.7.13</a>
      
    </div>

    

    
  </body>
</html>